Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 606)
+++ channels/chan_sip.c	(working copy)
@@ -6955,6 +6955,7 @@
 	 * we should decode the uri before storing it in the channel, but leave it encoded in the sip_pvt
 	 * structure so that there aren't issues when forming URI's
 	 */
+	ast_channel_unlock(tmp);
 	if (ast_exists_extension(NULL, i->context, i->exten, 1, i->cid_num)) {
 		/* encoded in dialplan, so keep extension encoded */
 		ast_copy_string(tmp->exten, i->exten, sizeof(tmp->exten));
@@ -6963,6 +6964,7 @@
 		ast_uri_decode(decoded_exten);
 		ast_copy_string(tmp->exten, decoded_exten, sizeof(tmp->exten));
 	}
+	ast_channel_lock(tmp);
 
 	/* Don't use ast_set_callerid() here because it will
 	 * generate an unnecessary NewCallerID event  */
